/////////////////////////////////////////////////////////////
//
// Filename:	classify.cc
// Description: 
//
//
// Copyright (c) 1998 Xiaojuan Feng 
//
/////////////////////////////////////////////////////////////
#include <math.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <fstream.h>
#include <stdio.h>

#include "classifyTSBN.hh"
#include "util.hh"

int  main(int argc, char** argv)
{
 int		i,j,k;
 FILE*		fp;

 // $usage a 23 probs*.dat imagesTe.dat 
 //  imagesMlpTeVE_intP.dat  conf.dat
 if ((argc != 6)&&(argc != 7))
    errors("Usage: $  type  num_image  file_CPTs \
            label_images virtual_evidence  output\n");

 // obtain parameters from inputs
 s_int nclass = NUMBER_CLASSES; 
 s_int nlevel = NUMBER_LEVELS;  
 s_int nrow   = NUMBER_ROWS;    
 s_int ncol   = NUMBER_COLS;    
 s_int ncpt   = NUMBER_CPTS;   
 s_int nimage = atoi( argv[2] );
 int	   nsize = nrow*ncol*nimage;

 // obtain the initial CPTs
 // format: 
 // first row: priors
 // the first CPT between root node to level 1
 // the second CPT between Level 1 to Level 2
 // ...
 if ((fp=fopen( argv[3], "r")) == NULL)
    errors("file_CPTs doesn't exist\n"); 
 float*** probs = fmatrix(ncpt, nclass, nclass);
 for (i=0; i<nclass; ++i)
      fscanf(fp, "%f", &probs[0][0][i]);
 for (k=1; k<ncpt; ++k)
 for (i=0; i<nclass; ++i)
 for (j=0; j<nclass; ++j)
      fscanf(fp, "%f", &probs[k][i][j]);
 fclose(fp);


 // Set information about the structure of the B.net
 ClassifyTSBN*  net = new ClassifyTSBN(nclass, nlevel, nrow,  
				       ncol, ncpt, nimage);

 // Training by using different evidences and different methods
 s_int	        maxiter = 200;
 float          tol = 0.00000001;
 float	   	temp;
 s_int*         images;
 float**        imagesv;
 
 switch (argv[1][0]){
 
 case 'p':
        net->Classify( argv[4], argv[5], 
                       probs, argv[6] );
	break;

 case 'a':
        // Hard and virtual evidences trainning
        //train->classify( argv[4], argv[5], probs, argv[6] );
        // for print one confusion 
        net->ClassifyBest( argv[4], argv[5], 
                            probs, argv[6] );
	break;

 case 'c':
        // BEL* and output conditional probability
        // argv[4]: hard ev; argv[5]: ve; 
        //argv[6]: calculated conditional probability
	net->ClassifyBestCondp( argv[4], argv[5], 
                                probs, argv[6]);
        break;

 default:
	printf("The first argument short be:\n \
                 'p'->MPM, output the confusion matrix; \n \
		 'a'->MAP, output the confusion matrix; \n \
		 'c'->classify, output conditional probs.\n;");
        break;
 } // end of switch







} // end of main 
