/////////////////////////////////////////////////////////////
// Filename:	classify_1.cc
//
// Copyright 1998  (c)  Xiaojuan Feng
//
/////////////////////////////////////////////////////////////
#include <math.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <fstream.h>
#include <stdio.h>
#include "mex.h"
#include <matrix.h>
#include "classifyTSBN.hh"
#define NC 7

void classify_1( char*  fname, double* ve, double* labelB);



void mexFunction(int            nlhs, 
                 mxArray*       plhs[], 
                 int            nrhs, 
                 const mxArray* prhs[])
{
 //  Check for proper number of arguments 
 if (nrhs != 2) {
    mexErrMsgTxt("classify_quadtree requires two input arguments.");
 } else if (nlhs != 1) {
    mexErrMsgTxt("net requires one output argument.");
 } 

 //
 int   buflen, status;
 char	fname[30]; 
 buflen = (mxGetM(prhs[0])*mxGetN(prhs[0]))+1;
 status = mxGetString(prhs[0],  fname, buflen);
 //
 double   *ve = mxGetPr( prhs[1]) ;
 // 
 int        dimsv[2]={128,192};
 double*    labelB;
 plhs[0] = mxCreateNumericArray(2, dimsv, mxDOUBLE_CLASS, 
                                mxREAL);
 if (plhs[0] == NULL)  
 mexErrMsgTxt("Could not create mxArray.\n");
 labelB = (double *)mxGetPr(plhs[0]);

 classify_1( fname, ve,  labelB);

 return;
 
}


void classify_1( char*  fname, double* ve, double* labelB)
{
 int		i,j,k;
 short int nclass = NC;
 short int nlevel = 8;
 short int nrow   = 128;
 short int ncol   = 192;
 short int ncpt   = 13;
 short int nimage = 1;
 char      str[30];
 FILE* 	   fp;

 // obtain the initial CPTs
 // format: 
 // first row: priors
 // the first CPT between root node to level 1
 // the second CPT between Level 1 to Level 2
 // ...
 if ((fp=fopen(fname, "r")) == NULL)
    errors("probs*.dat doesn't exist\n"); 
 float*** probs = fmatrix(ncpt, nclass, nclass);
 for (i=0; i<nclass; ++i)
     fscanf(fp, "%f", &probs[0][0][i]);
 for (k=1; k<ncpt; ++k)
 for (i=0; i<nclass; ++i)
 for (j=0; j<nclass; ++j)
      fscanf(fp, "%f", &probs[k][i][j]);
 fclose(fp);


 // Set information about the structure of the B.net
 mexPrintf(" constructing tree-structured belief network .....\n");
 ClassifyTSBN*  net = new ClassifyTSBN(nclass, nlevel,
                                       nrow, ncol, 
 				       ncpt, nimage);
 
 sprintf(str, "%s.ve", fname);
 //train->classify( ve,  probs, labelB );
 net->ClassifyBest( ve, probs, labelB);

} // end of main 


