function display_colour_key(nclass)
%
% Aim:  To display the seven coulours and their names
% Xiaojuan Feng     16/04/98
%

% Position the figure at the top-left

%bdwidth = 10;
%topbdwidth = 60;
%set(0, 'Units', 'pixels')
%scnsize=get(0, 'ScreenSize');
%pos1=[scnsize(3)*3/4-2*bdwidth, scnsize(4)*2/3-bdwidth, ...
%      scnsize(3)*0.25, scnsize(4)*2/5-(topbdwidth+bdwidth)];
%figure('Position', pos1);

% 00 | Undefined             
Black =[  0,  0,  0  ];
% 01 | Atmospheric Phenomena 
White =[  1,  1,  1  ];
% 02 | Vegetation            
Bright_Green = [  0, 1,  0  ];
% 03 | Road Surface Markings 
Yellow = [ 1, 1,  0 ];
% 04 | Road Surface_border Other    
Dark_Cyan = [ 0, 153/255, 153/255 ];
% 05 | Building             
Blue = [  0,  0, 1];         
% 06 | Street furniture          
Brown = [   204/255, 153/255,  0 ];
% 07 | Car                   
Bright_Red = [ 1,  0,  0 ];

labelcolour1 = [Black; White; Bright_Green; 
                Yellow; Dark_Cyan; Blue;
		Brown; Bright_Red];

if nclass == 7
   a=[0, 1,2,3,4,5,6,7];
   b=a';
   image(b+1); colormap(labelcolour1)
   %display_label7(a');
   axis([0.5,5,0.5,8.5]);
   set(gca,'YTick',[0, 1,2,3,4,5,6,7,8]);
   %title('Color list');
   hold on
   plot([0.5,1.5],[0.5,0.5])
   plot([0.5,0.5],[0.5,7.5])
   plot([1.5,1.5],[0.5,7.5])
   plot([0.5,1.5],[7.5,7.5])
   text('Position', [1.7,1], 'String', ' 0: Undefined pixel', 'FontSize', 10);
   text('Position', [1.7,2], 'String', ' 1: Sky', 'FontSize', 10);
   text('Position', [1.7,3], 'String', ' 2: Vegetation', 'FontSize', 10);
   text('Position', [1.7,4], 'String', ' 3: Road Markings', 'FontSize', 10);
   text('Position', [1.7,5], 'String', ' 4: Road Surface-Border', 'FontSize', 10);
   text('Position', [1.7,6], 'String', ' 5: Building', 'FontSize', 10);
   text('Position', [1.7,7], 'String', ' 6: Street-Furniture', 'FontSize', 10);
   text('Position', [1.7,8], 'String', ' 7: Mobile Object', 'FontSize', 10);
   axis off

elseif nclass == 11
   a=[1,2,3,4,5,6,7,8,9,10,11];
   a= a' * ones(1,3);
   %display_label7(a);
   hold on
   plot([0.5,3.5],[11.5,11.5]);
   plot([0.5,3.5],[0.5,0.5]);
   plot([0.5,0.5],[0.5,11.5]);
   plot([3.5,3.5],[0.5,11.5]);
   axis([0,20,0.5,11.5])
   axis off
   set(gca,'YTick',[1,2,3,4,5,6,7,8,9,10,11]);
   set(gca,'XTick',[1,2,3,4,5,6,7,8,9,10,11]);
   title('Color list');
   text('Position', [4,1], 'String', ' 1: Sky');
   text('Position', [4,2], 'String', ' 2: Vegetation');
   text('Position', [4,3], 'String', ' 3: Road Markings');
   text('Position', [4,4], 'String', ' 4: Road Other');
   text('Position', [4,5], 'String', ' 5: Road Border Misc.');
   text('Position', [4,6], 'String', ' 6: Building');
   text('Position', [4,7], 'String', ' 7: Bounding Object');
   text('Position', [4,8], 'String', ' 8: Road Sign');
   text('Position', [4,9], 'String', ' 9: Electrical Object');
   text('Position', [4.5,10], 'String', '10: Ill. Shadow');
   text('Position', [4.5,11], 'String', '11: Car');
   axis off
   
end


