function [temp]= display_confusion7(infm)
% Aim: To display the conditional probability table


%fig=gcf;
%close(fig)

if ndims(infm)==3
   % three with each square represents a confusion matrix 
   % to display the total confusion matrix
   temp = sum(infm,3);
else
   temp = infm;
end

% total correct classify:
a=temp(1,1);
for i=2:1:7
    a = a+temp(i,i);
end
a= a/sum(sum(temp,2),1);

%
s = size(temp);
for i=1:1:s(1)
    b=sum(temp(i,:),2);
    if b >1e-31
       temp(i,:) = temp(i,:) ./ (b*ones(1,s(1)));
    end
end

% plot 
images=ones(s(1)*100, s(1)*100);

for i=1:1:s(1)
    i1 = (i-1)*100+1; 
    for j=1:1:s(2)
        j1 = (j-1)*100+1;
        item =floor(temp(i,j)*100);
        k=floor((100-item)/2);
        images((i1+k):(i1+k+item),(j1+k):(j1+k+item))=0;
        
   end
end


display_label(images);
%image( images, 'XData', [0.6 11.5], 'YData', [0.6 11.5]); colormap( labelcolour2 );
%axis off
%axis([1 11 1 11]);
axis square

set(gca,'XTick',[1,2,3,4,5,6,7]);
set(gca,'YTick',[1,2,3,4,5,6,7]);
title( ['Total correct classification:', num2str( a )])
xlabel('To:')
ylabel('From:')




