////////////////////////////////////////////////////////////////
// Filename:  reduce_label_1.cc
// Aim:         To reduce 4 times of a label image.
//
// Copyright  1998 (c)     Xiaojuan Feng
//
////////////////////////////////////////////////////////////////
#include <math.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <fstream.h>
#include <stdio.h>
#include "mex.h"

void    reduce_label_1( double* labelTrue, double* labelRedu);


////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////
void mexFunction(int            nlhs,
                 mxArray*       plhs[], 
                 int            nrhs, 
                 const mxArray* prhs[])
{

  // Check for proper number of arguments 
  if (nrhs != 1) {
  mexErrMsgTxt("reduce_label_1 requires one  input argument: true_label");
  } else if  (nlhs != 1) {
    mexErrMsgTxt("reduce_label_1  requires one output argument.");
  }

  // 
  double    *labelTrue = mxGetPr(prhs[0]);
  double    *labelRedu; 
  int        dimsv[2]={128,192};

  plhs[0] = mxCreateNumericArray(2, dimsv, mxDOUBLE_CLASS, 
                                 mxREAL);
  if (plhs[0] == NULL)  
  mexErrMsgTxt("Could not create mxArray.\n");
  labelRedu = (double *)mxGetPr(plhs[0]);

  reduce_label_1( labelTrue, labelRedu);
 
  return;
 }


////////////////////////////////////////////////////////////////
//
////////////////////////////////////////////////////////////////
void    reduce_label_1( double* labelTrue, 
                        double* labelRedu)
{
 int		i,j, pi,pj,k,index;

 // obtain parameters from inputs
 short int 	nrow   = 128;
 short int 	ncol   = 192;
 short int*     nums = new short int [12];
  /*
 short int      labelT[128][192];
 for (i=0; i<128; ++i)
 for (j=0; j<192; ++j)
     labelT[i][j]=labelTrue(j*128+i
 */
  for (i=0; i<nrow; ++i)
  for (j=0; j<ncol; ++j) {
      for (k=0; k<12; ++k) nums[k] = 0;
      for (pi=0; pi<4; ++pi)
      for (pj=0; pj<4; ++pj) 
           ++nums[(int)labelTrue[(4*j+pj)*(4*nrow)+4*i+pi]];
      index=0;
      for (k=1; k<12; ++k)
         if (nums[index] <nums[k]) index=k;
      labelRedu[ j*nrow+i] = index;
  }
 
} // end of main 






