#include "const.hh"

//  Labels11
#define MAX_LABELS_OUTPUT    7

#define UNDEFINED            0
#define CLOUDS               1
#define VEGETATION           2
#define ROAD_SURFACE_MARKING 3
#define ROAD_SURFACE_BORDER  4
#define BUILDING             5
#define STREET_FURNITURE     6
#define MOBILE_OBJECT_CAR    7

#define REJECTED             99
#define WRONG               -1

// labels92
#define MAX_LABELS                             93

#define Undefined_Other                         0
#define Atmospheric_Phenomena                   1
#define         AP_Clear_Sky                    2
#define 	AP_Cloud                        3
#define 	AP_Mist_Smoke                   4
#define 	AP_Other                        5
#define Bounding_Object                         6
#define 	BO_Fence                        7
#define 	BO_Gate                         8
#define 	BO_Wall                         9
#define 	BO_Other                       10
#define Building                               11
#define 	B_Chimney                      12
#define 	B_Door                         13
#define 	B_Roof                         14
#define 	B_Wall                         15
#define 	B_Window                       16
#define 	B_Other                        17
#define Electrical_Object                      18 
#define 	EO_Electricity_Pylon           19
#define 	EO_Lamp_Post                   20
#define 	EO_Telegraph_Pole              21
#define 	EO_Wire                        22
#define 	EO_Other                       23
#define Illumination                           24 
#define 	I_Shadow                       25
#define 	I_Specularity                  26
#define 	I_Other                        27 
#define Landscape                              28
#define         L_Stone_Rock                   29 
#define 	L_Soil                         30
#define 	L_Vegetation                   31
#define 		L_V_Bush               32
#define 		L_V_Grass              33 
#define 		L_V_Hedge              34
#define 		L_V_Tree               35
#define 		L_V_Other              36
#define 	L_Water                        37
#define 	L_Other                        38
#define Mobile_Object                          39 
#define 	MO_Bike                        40
#define 	        MO_B_Body              41
#define 		MO_B_Wheel             42
#define 		MO_B_Other             43
#define 	MO_Car                         44
#define 	        MO_C_Body              45
#define 		MO_C_Wheel             46 
#define 		MO_C_Window            47
#define 		MO_C_Other             48
#define 	MO_Person                      49 
#define 	MO_Truck                       50
#define 	        MO_T_Body              51
#define 		MO_T_Wheel             52
#define 		MO_T_Window            53
#define 		MO_T_Other             54
#define 	MO_Van                         55
#define 	        MO_V_Body              56
#define 		MO_V_Wheel             57
#define 		MO_V_Window            58
#define 		MO_V_Other             59
#define 	MO_Other                       60
#define Road_Object                            61
#define 	RO_Bridge                      62
#define 	RO_Road_Border                 63
#define 	        RO_RB_Concrete         64
#define 		RO_RB_Drain            65
#define 		RO_RB_Grass            66
#define 		RO_RB_Gravel           67
#define 		RO_RB_Kerb_Stone       68
#define 		RO_RB_Leaves           69
#define 		RO_RB_Mud              70
#define 		RO_RB_Stone_Rock       71
#define 		RO_RB_Tarmac           72
#define 		RO_RB_Water            73
#define 		RO_RB_Other            74
#define 	RO_Road_Sign                   75
#define 	RO_Road_Surface                76
#define 		RO_RS_Concrete         77
#define 		RO_RS_Drain            78
#define 		RO_RS_Grass            79
#define 		RO_RS_Gravel           80
#define 		RO_RS_Leaves           81
#define 		RO_RS_Mud              82
#define	                RO_RS_Marking          83
#define 		        RO_RS_M_Centre 84
#define 			RO_RS_M_Edge   85
#define 			RO_RS_M_Other  86
#define 		RO_RS_Stone_Rock       87
#define 		RO_RS_Tarmac           88
#define 		RO_RS_Water            89
#define 		RO_RS_Other            90
#define 	RO_Traffic_Signal              91
#define 	RO_Other                       92


//  RGB colours

#define R_LIGHT_BLUE 49
#define G_LIGHT_BLUE 255
#define B_LIGHT_BLUE 255

#define R_GREEN 12
#define G_GREEN 170
#define B_GREEN 12

#define R_BRIGHT_YELLOW 255
#define G_BRIGHT_YELLOW 238
#define B_BRIGHT_YELLOW 0

#define R_GREY 90
#define G_GREY 100
#define B_GREY 120

#define R_YELLOW_BROWN 180
#define G_YELLOW_BROWN 150
#define B_YELLOW_BROWN 0

#define R_BRICK_RED 175
#define G_BRICK_RED 40
#define B_BRICK_RED 40

#define R_BROWN 130
#define G_BROWN 30
#define B_BROWN 30

#define R_BRIGHT_RED 255
#define G_BRIGHT_RED 0
#define B_BRIGHT_RED 0

#define R_WHITE 250
#define G_WHITE 230
#define B_WHITE 230

#define R_BLUE_GREY 100
#define G_BLUE_GREY 100
#define B_BLUE_GREY 130

#define R_TASTEFUL_PINK 255
#define G_TASTEFUL_PINK 33
#define B_TASTEFUL_PINK 222

#define R_BLU_WHITE 150
#define G_BLU_WHITE 200
#define B_BLU_WHITE 255

#define R_ORANGE 255
#define G_ORANGE 200
#define B_ORANGE 0

#define R_YELLOW 255
#define G_YELLOW 255
#define B_YELLOW 0

#define R_PINK 255
#define G_PINK 200
#define B_PINK 255

#define R_PURPLE 255
#define G_PURPLE 0
#define B_PURPLE 150

//#define R_WHITE 255
//#define G_WHITE 255
//#define B_WHITE 255

#define R_PALE_BLUE 0 
#define G_PALE_BLUE 255
#define B_PALE_BLUE 255

#define R_VIOLET 150
#define G_VIOLET 0
#define B_VIOLET 255

#define R_RED 255
#define G_RED 0
#define B_RED 0

#define R_MID_GREEN 0
#define G_MID_GREEN 255
#define B_MID_GREEN 150

#define R_OLIVE_GREEN 0
#define G_OLIVE_GREEN 170
#define B_OLIVE_GREEN 0

#define R_LIGHT_GREEN 0
#define G_LIGHT_GREEN 255
#define B_LIGHT_GREEN 0

#define R_BRIGHT_GREEN 0
#define G_BRIGHT_GREEN 170
#define B_BRIGHT_GREEN 0

#define R_RED1 200
#define G_RED1 0
#define B_RED1 0

#define R_RED2 255
#define G_RED2 20
#define B_RED2 0

#define R_PINK1 255
#define G_PINK1 90
#define B_PINK1 200

#define R_PINK2 255
#define G_PINK2 150
#define B_PINK2 150

#define R_PINK3 255
#define G_PINK3 150
#define B_PINK3 200

#define R_PALE_YELLOW 255
#define G_PALE_YELLOW 255
#define B_PALE_YELLOW 150

#define R_SALMON 255
#define G_SALMON 120
#define B_SALMON 120

#define R_BRIGHT_BLUE 0
#define G_BRIGHT_BLUE 0
#define B_BRIGHT_BLUE 255

#define R_DEEP_PURPLE 255
#define G_DEEP_PURPLE 0
#define B_DEEP_PURPLE 255

#define R_BLACK 0
#define G_BLACK 0
#define B_BLACK 0

#define R_BHO 0
#define G_BHO 0
#define B_BHO 0



//
#define LINESIZE	       5000
#define SIZE_OF_DOUBLE_POINTER 4
#define SIZE_OF_INT_POINTER    4
#define STOP_CODE      ((unsigned char) 0xff)

#define LAB_MAGIC 0x30f09f66 //Magic number in header of 
                             //labelmap files for unique 
                             //type-identification
#define LABELMAP_OBJECTS_IDENTITIES	11 
                             //The possible types of labelmap 
                             //(numbers must start at >1) 
                             //Hand-labelled object identities
