////////////////////////////////////////////////////////////
//
//  Filename:	 tsbn.hh
//  Description: Definition file for the InputTSBN class.
//
//  Copyright (c) 1998 Xiaojuan Feng
//
////////////////////////////////////////////////////////////

#ifndef		InputTSBN_h
#define		InputTSBN_h

#include "tsbn.hh"
#include "util.hh"

class InputTSBN {

public:
        InputTSBN(s_int  nclass, 
                  s_int  nlevel,
                  s_int  nrow,   
                  s_int  ncol,
                  s_int  ncpt,   
                  s_int  nimage);
        InputTSBN(s_int  nclass, 
                  s_int  nlevel,
                  s_int  nrow,   
                  s_int  ncol,
                  s_int  ncpt,   
                  s_int  nimage,
                  s_int  try0);
        ~InputTSBN();

protected:
        TSBN*   tree;
        s_int	num_image;
 	s_int*  SetNumParent( s_int );
 	s_int*  SetNumChildren( s_int, s_int, s_int );
        void    SetSizeLevel( s_int,  s_int, s_int, 
                              s_int*, s_int*); 
	s_int*  ChangeFormat( s_int* images );
	void    ChangeFormat( s_int* images, 
                              s_int* labels );
        float** ChangeFormat( float** images );
        void    ChangeFormat( float** images, 
                              float** labels );
        int     GetNumMissingPixel( s_int* );

}; // end of class InputTSBN

#endif
