//////////////////////////////////////////////////////////
//
// Filename:  trainTSBN.hh
// Description: Definition file for the TrainTSBN class.
//
//  Copyright (c) 1998 Xiaojuan Feng
//
/////////////////////////////////////////////////////////

#ifndef		TRAINTSBN_h
#define		TRAINTSBN_h


#include "tsbn.hh"
#include "inputTSBN.hh"
#include "util.hh"

class TrainTSBN: public InputTSBN {

public:
        TrainTSBN(s_int,s_int,s_int,   
                  s_int,s_int,s_int);
        ~TrainTSBN();
        void  TrainML(s_int*,float***,
                      float,s_int);
        void  TrainML(float**,float***, 
                      float,s_int);
        void  TrainCMLscg(char*,char*,float***,float*);
        void  TrainCMLscgFast(s_int*,float**,float***,float*);
  /*
        void  train_MMI(char*     fimage1, 
                        char*     fimage2, 
			float***  probs, 
                        float     eta,
                        float     tol, 
                        s_int maxiter);
			*/
  //void  LogMargLike(char*,float***);
private:
        void    RunQuadtree(float***, float*);
        void    Iteration( float***,s_int*,float*);
        void    Iteration( float***,float**,float*);
  /*
        void    iteration_MMI( float***   probs,
                                   char*      fimage1,
                                   char*      fimage2,
                                   float      eta,
                                   float*     logp);
				   */
        void    CalFunctionGradient(char*,char*, 
				    float***,double*,
				    float***);
        void    CalFunctionGradientFast(s_int*,float**, 
				        float***,double*,
				        float***);
        void 	CheckGradient(char*,char*,float***);

}; // end of class TrainBeliefNet

#endif
