

/////////////////////////////////////////////////////////////
//
// Filename:	norm_features.cc
//
// Aim: To calculate the normalised 40 features from each 
//      subimages  (ntimes * ntimes).
//
// Copyright 1998 Xiaojuan Feng 
//
/////////////////////////////////////////////////////////////
#include <math.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>

#include "hipsCD7.hh"
#include "const.hh"

int  main(int argc, char** argv)
{
 int	i, j, total_num;
 char	fname[SIZE_FILENAME];
 char	fnames[SIZE_FILENAME];
 char	fname_temp[SIZE_FILENAME];
 char	command[SIZE_FILENAME];
 Hips*	image;
 FILE	*fp1, *fp2;
 void	errors(char*);


 // Example:
 // norm_features image_train 4 para40.dat
 if (argc !=4  ) 
 errors("Usage: %s image_file_name ntimes norm_parameters \n");


 short int ntimes = atoi( argv[2] );
 
 short int	nfeature = 40;
 float**	npare;

 npare = new float * [nfeature];
 for (i=0; i<nfeature; ++i) npare[i] = new float [2];

 
 fp1 = fopen(argv[3], "r"); 
 for (i=0; i<nfeature; ++i)
 for (j=0; j<2; ++j) 
     fscanf(fp1, "%f", &npare[i][j]);
 fclose(fp1);

 strcpy(fnames, argv[1]);
 fp1 = fopen(fnames, "r");
 fscanf(fp1, "%d", &total_num);
 for (i=0; i<total_num; ++i) {
     fscanf(fp1, "%s", fname);
     printf("%s\n", fname);

     for (j=8; j>=0; --j)
         fname_temp[j] = fname[strlen(fname)-9+j];
     fname_temp[9]='\0';
     sprintf(command, "cp %s.col.hips .", fname);
     system(command);
     sprintf(command, "cp %s.obj .", fname);
     system(command);
     sprintf(command, "cp %s.obj.def .", fname);
     system(command);
     image = new Hips(fname_temp);
     sprintf(command, "rm -rf %s.*", fname_temp);
     system(command);
   
     // change filenames for matlab
     for (j=0; j<strlen(fname_temp); ++j)
         if (fname_temp[j] == '-')  
            fname_temp[j]='_'; 
     strcat( fname_temp, ".fea");
     fp2 = fopen( fname_temp, "w");
     // calculate the features
     image->CalculateNormFeature( npare, ntimes, &fp2 );
     fclose(fp2); 

     sprintf(command, "gzip %s", fname_temp);
     system(command);   
 }
 
 fclose(fp1);


} // end of main


