

/////////////////////////////////////////////////////////////
// Filename:	reduce_label_image.cc
//
// Aim: To create the reduced label images. The label images
//      given in file "image_file_name" are reduced "ntimes" 
//      times and the reduced images are stored in file 
//      "output_file".
//      
// Copyright (c) 1999 Xiaojuan
/////////////////////////////////////////////////////////////
#include <math.h>
#include <iostream.h>
#include <string.h>
#include <stdlib.h>

#include "hipsCD7.hh"
#include "const.hh"

int main(int argc, char** argv)
{
 int		i, j, total_num;
 char 		fname[SIZE_FILENAME];
 char 		fnames[SIZE_FILENAME];
 char           fname_temp[SIZE_FILENAME];
 char           command[SIZE_FILENAME];
 Hips*		image;
 FILE  	 	*fp1, *fp2;
 void		errors(char*);

 // $usage image_train 4 imagesTr.dat
 if (argc != 4 ) 
 errors("reduce_image  image_file_name ntimes output_file\n");
 strcpy(fnames, argv[1]);
 fp1 = fopen(fnames, "r");

 short int ntimes = atoi( argv[2] );
    
 fp2 = fopen( argv[3], "w");

 fscanf(fp1, "%d", &total_num);
 for (i=0; i<total_num; ++i) {
     fscanf(fp1, "%s", fname);
     printf("%s\n", fname);

     for (j=8; j>=0; --j)
         fname_temp[j] = fname[strlen(fname)-9+j];
     fname_temp[9] = '\0';
     sprintf(command, "cp %s.col.hips .", fname);
     system(command);
     sprintf(command, "cp %s.obj .", fname);
     system(command);
     sprintf(command, "cp %s.obj.def .", fname);
     system(command);

     image = new Hips(fname_temp);
     image->ReduceLabelImage( ntimes, &fp2 );
     //image->reduce_fuzzy_image( ntimes, &fp2 );
     sprintf(command, "rm -rf %s.*", fname_temp);
     system(command);    
 }
 fclose(fp2);      
 fclose(fp1);

} // end of main



